﻿using System;

using Android.App;
using Android.App.Admin;
using Android.Content;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Android.OS;

namespace AndroidApplication1
{
    [Activity(Label = "AndroidApplication1", MainLauncher = true, Icon = "@drawable/icon")]
    public class Activity1 : Activity
    {
        private const int RequestCodeEnableAdmin = 0;

        protected override void OnCreate(Bundle bundle)
        {
            base.OnCreate(bundle);

            // Set our view from the "main" layout resource
            SetContentView(Resource.Layout.Main);

            // Get our button from the layout resource,
            // and attach an event to it
            Button button = FindViewById<Button>(Resource.Id.MyButton);

            var component = new ComponentName("AndroidApplication1.AndroidApplication1", "androidapplication1.AdminComponentReceiver");
            var dpm = (DevicePolicyManager)BaseContext.GetSystemService(DevicePolicyService);
            
            button.Click += delegate
                                {
                                    if (!dpm.IsAdminActive(component))
                                    {
                                        Intent intent = new Intent(DevicePolicyManager.ActionAddDeviceAdmin);
                                        intent.PutExtra(DevicePolicyManager.ExtraDeviceAdmin, component);
                                        StartActivityForResult(intent, RequestCodeEnableAdmin);
                                    }

                                    /*
                                    if (dpm.IsAdminActive(component))
                                    {
                                        dpm.RemoveActiveAdmin(component);
                                    }
                                    */
                                };
        }
    }

    [BroadcastReceiver(Label = "Device Admin Sample", Permission = "android.permission.BIND_DEVICE_ADMIN")]
    [MetaData("android.app.device_admin", Resource = "@xml/admin")]
    [IntentFilter(new[] { "android.app.action.DEVICE_ADMIN_ENABLED" })]
    public class AdminComponentReceiver : DeviceAdminReceiver
    {
    }
}